#include <Arduino.h>
#include <TFT_eSPI.h>
#include <SPI.h>
#include <Wire.h>

#define RGB_COLOR(r, g, b) (((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3))

#define TFT_CS   15  // GPIO15, D8 on NodeMCU
#define TFT_RST  4   // GPIO4, D2 on NodeMCU
#define TFT_DC   5   // GPIO5, D1 on NodeMCU

TFT_eSPI tft = TFT_eSPI();
uint16_t lightPink = RGB_COLOR(255, 130, 150);
uint16_t lightYellow = RGB_COLOR(255, 255, 100);
uint16_t lightBlue = RGB_COLOR(150, 150, 255);

void drawHappyFace() {
    tft.init();
    tft.fillScreen(lightPink);  // Fill screen with a light pink background

    // draw half of a black circle
    tft.fillCircle(64, 85, 20, ST7735_BLACK);
    tft.fillRect(44, 65, 45, 20, lightPink);
    
    // Left Eye
    tft.fillCircle(40, 64, 20, ST7735_BLACK);
    tft.fillCircle(50, 60, 5, ST7735_WHITE);
    tft.fillCircle(40, 64, 7, ST7735_WHITE);

    // Right Eye
    tft.fillCircle(88, 64, 20, ST7735_BLACK); 
    tft.fillCircle(98, 60, 5, ST7735_WHITE);  
    tft.fillCircle(88, 64, 7, ST7735_WHITE);  
    
    tft.fillRect(20, 75, 40, 10, lightPink); // Left eye
    tft.fillRect(68, 75, 40, 10, lightPink); // Right eye
}



void drawSadFace() {
    tft.init(); 
    tft.fillScreen(lightBlue); 
    
    tft.fillCircle(64, 100, 20, ST7735_BLACK);
    tft.fillRect(44, 95, 45, 27, lightBlue); 

//EYES
    // Left Eye
    tft.fillCircle(40, 64, 20, ST7735_BLACK);
    tft.fillCircle(50, 60, 5, ST7735_WHITE); 

    // Right Eye
    tft.fillCircle(88, 64, 20, ST7735_BLACK);
    tft.fillCircle(98, 60, 5, ST7735_WHITE);
}

void drawSleepyFace() {
    tft.fillScreen(lightBlue);
    
    // Draw sleepy eyes
    tft.fillCircle(40, 64, 20, ST7735_BLACK); 
    tft.fillCircle(50, 60, 5, ST7735_WHITE); 

    // Right Eye
    tft.fillCircle(88, 64, 20, ST7735_BLACK);
    tft.fillCircle(98, 60, 5, ST7735_WHITE);

    tft.drawLine(40, 80, 88, 80, ST7735_BLACK); 

}

void drawExcitedFace() {
    tft.init();
    tft.fillScreen(lightYellow); 

    tft.fillCircle(64, 85, 20, ST7735_BLACK); 
    tft.fillRect(44, 65, 45, 20, lightYellow); 

//EYES
    // Left Eye
    tft.fillTriangle(30, 64, 50, 64, 40, 44, ST7735_BLACK);
    tft.fillTriangle(50, 64, 30, 64, 40, 50, lightYellow);  

    // Right Eye
    tft.fillTriangle(78, 64, 98, 64, 88, 44, ST7735_BLACK);
    tft.fillTriangle(98, 64, 78, 64, 88, 50, lightYellow); 
}
